
package es.gob.administracion.dehu.gd;

/**
 * Please modify this class to meet your needs
 * This class is not complete
 */

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.math.BigInteger;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.namespace.QName;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.soap.SOAPFaultException;

import org.apache.commons.io.FileUtils;
import org.apache.cxf.endpoint.Client;
import org.apache.cxf.frontend.ClientProxy;
import org.apache.cxf.interceptor.LoggingInInterceptor;
import org.apache.cxf.interceptor.LoggingOutInterceptor;
import org.apache.cxf.transport.http.HTTPConduit;
import org.apache.cxf.transports.http.configuration.HTTPClientPolicy;
import org.apache.cxf.ws.security.wss4j.WSS4JOutInterceptor;
import org.apache.wss4j.dom.handler.WSHandlerConstants;

import es.gob.administracion.punto_unico_notificaciones.consultaacusepdf.ConsultaAcusePdf;
import es.gob.administracion.punto_unico_notificaciones.consultaacusepdf.IdentificadorAcusePdf;
import es.gob.administracion.punto_unico_notificaciones.localiza.Localiza;
import es.gob.administracion.punto_unico_notificaciones.peticionacceso.PeticionAcceso;
import es.gob.administracion.punto_unico_notificaciones.respuestaconsultaacusepdf.AcusePdf;
import es.gob.administracion.punto_unico_notificaciones.respuestaconsultaacusepdf.RespuestaConsultaAcusePdf;
import es.gob.administracion.punto_unico_notificaciones.respuestalocaliza.Envio;
import es.gob.administracion.punto_unico_notificaciones.respuestalocaliza.RespuestaLocaliza;
import es.gob.administracion.punto_unico_notificaciones.respuestapeticionacceso.DetalleDocumento;
import es.gob.administracion.punto_unico_notificaciones.respuestapeticionacceso.RespuestaPeticionAcceso;

/**
 * This is an example of DEHu GD client
 *
 */
public final class DEHuWs_Client {
	private static final String COMPARECER = "1";
	private static final BigInteger NOTIFICACION = new java.math.BigInteger("2");
	private static final QName SERVICE_NAME = new QName(
			"https://administracionelectronica.gob.es/notifica/ws/lema/1.0/", "DEHuWsService");
	
	// Test WSDL and endpoint location
	private static final String WSDL_LOCATION = "https://se-dehuws.redsara.es/wsdl/GD_Dehu/v2/Gd-Dehu-Ws_se.wsdl";
	private static final String ENDPOINT_LOCATION = "https://se-dehuws.redsara.es/ws/v2/lema";

	// TODO Config fill with the correct values
	private static final String NIF_RECEPTOR = "XXXXXXXXX";
	private static final String NIF_TITULAR = "XXXXXXXXX";
	private static final String NIF_DESTINATARIO = "XXXXXXXXX";

	private DEHuWs_Client() {
	}

	public static void main(String args[]) throws java.lang.Exception {
		URL wsdlURL;

		try {
			if (args.length > 0 && args[0] != null && !"".equals(args[0])) {
				File wsdlFile = new File(args[0]);
				if (wsdlFile.exists()) {
					wsdlURL = wsdlFile.toURI().toURL();
				} else {
					wsdlURL = new URL(args[0]);
				}
			} else {
				wsdlURL = new URL(WSDL_LOCATION);
			}

			DEHuWsService ss = new DEHuWsService(wsdlURL, SERVICE_NAME);
			DEHuWsPortType port = ss.getDEHuWsPort();
			// Use the BindingProvider's context to set the endpoint
			BindingProvider bp = (BindingProvider) port;
			bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, ENDPOINT_LOCATION);
			// Generate the client to add WS-Security
			Map<String, Object> inProps = new HashMap<String, Object>();
			Map<String, Object> outProps = new HashMap<String, Object>();

			// ... // how to configure the properties is outlined below;

			outProps.put(WSHandlerConstants.ACTION, "Signature");
			// TODO edit the file to put the correct properties
			outProps.put(WSHandlerConstants.SIG_PROP_FILE, "client_sign.properties");
			// TODO put the alias of the certificate,  org.apache.ws.security.crypto.merlin.keystore.alias
			outProps.put(WSHandlerConstants.USER, "XXXXX");
			outProps.put(WSHandlerConstants.PW_CALLBACK_CLASS, KeystorePasswordCallback.class.getName());
			outProps.put(WSHandlerConstants.SIG_KEY_ID, "DirectReference");
			outProps.put(WSHandlerConstants.MUST_UNDERSTAND, "false");
			outProps.put(WSHandlerConstants.USE_SINGLE_CERTIFICATE, "true");
			outProps.put(WSHandlerConstants.SIG_ALGO, "http://www.w3.org/2000/09/xmldsig#rsa-sha1");
			outProps.put(WSHandlerConstants.SIG_C14N_ALGO, "http://www.w3.org/2001/10/xml-exc-c14n#");
			outProps.put(WSHandlerConstants.SIG_DIGEST_ALGO, "http://www.w3.org/2000/09/xmldsig#sha1");
			outProps.put(WSHandlerConstants.SIGNATURE_PARTS, "{Content}{}Body");
			outProps.put(WSHandlerConstants.ENABLE_SIGNATURE_CONFIRMATION, "true");
			Client client = ClientProxy.getClient(port);

			// Debugging Logs even if its deprecated in CXF 3
			client.getInInterceptors().add(new LoggingInInterceptor());
			client.getOutInterceptors().add(new LoggingOutInterceptor());

			// Generating interceptors
			WSS4JOutInterceptor wssOut = new WSS4JOutInterceptor(outProps);
			org.apache.cxf.endpoint.Endpoint cxfEndpoint = client.getEndpoint();

			// Add the interceptors to client
			cxfEndpoint.getOutInterceptors().add(wssOut);

			// Add the specifications to the header
			final HTTPConduit httpConduit = (HTTPConduit) ClientProxy.getClient(port).getConduit();

			HTTPClientPolicy policy = new HTTPClientPolicy();
			policy.setConnectionTimeout(1000);
			policy.setReceiveTimeout(60000);
			policy.setAllowChunking(false);
			httpConduit.setClient(policy);

			System.getProperty("org.apache.xml.security.ignoreLineBreaks");

			List<Envio> envios = localiza(port);

			if (envios != null && !envios.isEmpty()) {
				DetalleDocumento documento = peticionAcceso(port, envios.get(0));
				if (documento != null) {
					// Transform the datahandler to byteArray to store the document
					final InputStream in = documento.getContenido().getHref().getInputStream();
					byte[] byteArray = org.apache.commons.io.IOUtils.toByteArray(in);
					// TODO: Change the PATH to the store the file.
					FileUtils.writeByteArrayToFile(new File("C:\\temporal\\" + documento.getNombre().replaceAll("\\W+", "")), byteArray);
					AcusePdf acuse = consultaAcusePdf(port, envios.get(0), documento.getCsvResguardo());
					// TODO Store the content of Acuse
				}
			}

			System.exit(0);
		} catch (MalformedURLException e) {
			e.printStackTrace();
			System.exit(-1);
		}

	}

	private static List<Envio> localiza(DEHuWsPortType port) {

		List<Envio> envios = null;
		System.out.println("Invoking localiza...");
		Localiza localiza = new Localiza();
		localiza.setNifTitular(NIF_TITULAR);
		localiza.setNifDestinatario(NIF_DESTINATARIO);
		localiza.setTipoEnvio(NOTIFICACION);
		try {
			RespuestaLocaliza respuesta = port.localiza(localiza);

			System.out.println("localiza._localiza_codigoRespuesta=" + respuesta.getCodigoRespuesta());
			System.out.println("localiza._localiza_descripcionRespuesta=" + respuesta.getDescripcionRespuesta());
			System.out.println("localiza._localiza_nifPeticion=" + respuesta.getNifPeticion());
			System.out.println("localiza._localiza_envios=" + respuesta.getEnvios());
			envios = respuesta.getEnvios();
			System.out.println("localiza._localiza_hayMasResultados=" + respuesta.isHayMasResultados());
			System.out.println(
					"localiza._localiza_opcionesRespuestaLocaliza=" + respuesta.getOpcionesRespuestaLocaliza());
		} catch (SOAPFaultException e) {
			System.out.println(e.getMessage());
			System.out.println(e.getCause());
		}
		return envios;

	}

	private static DetalleDocumento peticionAcceso(DEHuWsPortType port, Envio envio) throws IOException {

		System.out.println("Invoking peticionAcceso...");
		DetalleDocumento documento = null;
		PeticionAcceso peticionAcceso = new PeticionAcceso();
		peticionAcceso.setIdentificador(envio.getIdentificador());
		peticionAcceso.setCodigoOrigen(envio.getCodigoOrigen());
		peticionAcceso.setNifReceptor(NIF_RECEPTOR);
		peticionAcceso.setNombreReceptor("PRUEBAS DEHUWS");
		peticionAcceso.setEvento(COMPARECER);
		peticionAcceso.setConcepto(envio.getConcepto());
		try {
			RespuestaPeticionAcceso respuesta = port.peticionAcceso(peticionAcceso);

			System.out.println("peticionAcceso._peticionAcceso_codigoRespuesta=" + respuesta.getCodigoRespuesta());
			System.out.println(
					"peticionAcceso._peticionAcceso_descripcionRespuesta=" + respuesta.getDescripcionRespuesta());
			System.out.println("peticionAcceso._peticionAcceso_identificador1=" + respuesta.getIdentificador());
			System.out.println("peticionAcceso._peticionAcceso_codigoOrigen1=" + respuesta.getCodigoOrigen());
			System.out.println("peticionAcceso._peticionAcceso_fechaEvento=" + respuesta.getFechaEvento());
			System.out.println("peticionAcceso._peticionAcceso_documento=" + respuesta.getDocumento());
			System.out.println("peticionAcceso._peticionAcceso_opcionesRespuestaPeticionAcceso="
					+ respuesta.getOpcionesRespuestaPeticionAcceso());
			documento = respuesta.getDocumento();
		} catch (SOAPFaultException e) {
			// TODO: Manage the exceptions
			System.out.println(e.getCause());
		}

		return documento;
	}

	private static AcusePdf consultaAcusePdf(DEHuWsPortType port, Envio envio, String csvResguardo) throws IOException {

		AcusePdf acuse = null;
		System.out.println("Invoking consultaAcusePdf...");
		ConsultaAcusePdf consultaAcusePdf = new ConsultaAcusePdf();
		consultaAcusePdf.setIdentificador(envio.getIdentificador());
		consultaAcusePdf.setCodigoOrigen(envio.getCodigoOrigen());
		consultaAcusePdf.setNifReceptor(NIF_RECEPTOR);
		consultaAcusePdf.setIdentificadorAcusePdf(new IdentificadorAcusePdf());
		consultaAcusePdf.getIdentificadorAcusePdf().setCsvResguardo(csvResguardo);
		try {
			RespuestaConsultaAcusePdf respuesta = port.consultaAcusePdf(consultaAcusePdf);

			System.out.println("consultaAcusePdf._consultaAcusePdf_codigoRespuesta=" + respuesta.getCodigoRespuesta());
			System.out.println(
					"consultaAcusePdf._consultaAcusePdf_descripcionRespuesta=" + respuesta.getDescripcionRespuesta());
			System.out.println("consultaAcusePdf._consultaAcusePdf_acusePdf=" + respuesta.getAcusePdf());
			System.out.println("consultaAcusePdf._consultaAcusePdf_opcionesRespuestaConsultaAcusePdf="
					+ respuesta.getOpcionesRespuestaConsultaAcusePdf());
			acuse = respuesta.getAcusePdf();
		} catch (SOAPFaultException e) {
			// TODO: Manage the exceptions
			System.out.println(e.getCause());
		}
		return acuse;

	}


}
